#! /usr/bin/env python
# -*- coding: utf-8 -*- 
# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


"""
If a parameter is given, this must be the name of the file the problem is
loaded from.  Otherwise, the problem is loaded from stdin.

"""

# ==========================================================================
# set up the load path
#
import sys
import os.path

path = os.path.abspath(os.path.join(os.path.dirname(__file__), '..', 'lib'))
sys.path.append(path)
# ==========================================================================

# ==========================================================================
# the real program
#
import sevendown.loader
import sevendown.solver

# get stream with result
infile = sys.stdin
if len(sys.argv) > 1:
    infile = file(sys.argv[1])

# load problem from problem file
loader = sevendown.loader.Loader()
problem = loader.load(infile)

# solve problem
solver = sevendown.solver.StackSolver()
solution = solver.solve(problem)

if solution != None:
    print solution.formatResult()
# ==========================================================================
