/* A naive implementation of the Sieve of Eratosthenes
 *
 * Author: Manuel Holtgrewe
 */

#include <iostream>
#include <vector>

#include <cstdlib>
#include <cmath>

int main(int argc, char **argv)
  {
    if (argc == 1)
      { 
        std::cerr << "Usage: sieve UPPER_LIMIT" << std::endl;
        return 1;
      }
    
    int upper_limit = atoi(argv[1]);
    
    std::vector<bool> is_prime(upper_limit, true);
    
    // sieve
    for (int i = 2; i <= static_cast<int>(ceil(sqrt(upper_limit))); ++i)
      {
        for (int j = 2 * i; j <= upper_limit; j += i)
          { is_prime[j] = false; }
      }
    
    // print result
    for (int i = 2; i <= upper_limit; ++i)
      {
        if (is_prime[i])
          std::cout << i << std::endl;
      }
    
    return 0;
  }
