#! /usr/bin/env python
# -*- coding: utf-8 -*- 
# Copyright (c) 2008 Manuel Holtgrewe, Mathias Ziebarth, Lucas Lürich, Joachim Breitner
#
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the
# "Software"), to deal in the Software without restriction, including
# without limitation the rights to use, copy, modify, merge, publish,
# distribute, sublicense, and/or sell copies of the Software, and to
# permit persons to whom the Software is furnished to do so, subject to
# the following conditions:
#
# The above copyright notice and this permission notice shall be included
# in all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
# IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY
# CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT,
# TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
# SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.


import doctest

import sys

from unittest import TestLoader, TestSuite, TestResult, TextTestRunner

import test_graph
import test_loader
import test_undo
import test_solver
import test_rules
import test_utils

import system_test

if __name__ == "__main__":
    # run all unit tests
    modules = [test_graph, test_loader, test_undo, test_solver, test_rules, test_utils]
    
    verb = 0
    if "-v" in sys.argv: verb=2
    runner = TextTestRunner(verbosity=verb)
    suite = TestSuite([TestLoader().loadTestsFromModule(m) for m in modules])
    
    # run all doctests
    for mod in modules:
        suite.addTest(doctest.DocTestSuite(mod, optionflags=doctest.ELLIPSIS))

    runner.run(suite)
    
    # run all system tests
    #system_test.run_all()
